import javax.swing.JToolBar;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JSeparator;
import java.net.URL;

public class BarraDeHerramientas{
	
	//Definicin de URL de iconos para empaquetado
	URL url0 = this.getClass().getResource("images/New24.gif");
	URL url1 = this.getClass().getResource("images/Open24.gif");
	URL url2 = this.getClass().getResource("images/SaveAs24.gif");
	URL url3 = this.getClass().getResource("images/Exit24.gif");
	URL url4 = this.getClass().getResource("images/Close24.gif");
	
	//Iconos de nuestra barra de herramientas
	ImageIcon newicon = new ImageIcon(url0);
	ImageIcon openicon = new ImageIcon(url1);
 	ImageIcon saveicon = new ImageIcon(url2);
	ImageIcon exiticon = new ImageIcon(url3);
	ImageIcon closeicon = new ImageIcon(url4);
	
	//Botones que aadiremos a la barra de herramientas.
	JButton nue=new JButton(newicon); 	
 	JButton ab=new JButton(openicon);
 	JButton save=new JButton(saveicon);
 	JButton close=new JButton(closeicon);
 	JButton exit=new JButton(exiticon);
	JSeparator sep = new JSeparator();
	JTextField bustext = new JTextField(10);
	JButton buscar = new JButton("Buscar");
	//Clase getToolBar() que nos devolver la Barra de Herramientas de nuestro Editor.
	public JToolBar getToolBar(){

		//Definicin de Barra de Herramientas.
		JToolBar toolBar = new JToolBar();
	        toolBar.setFloatable(true);//La hacemos flotante por si no nos gusta donde esta.
		//Aadimos los botones.
		toolBar.add(nue);
 		toolBar.add(ab);
 		toolBar.add(save);
 		toolBar.add(close);
 		toolBar.add(exit);
		toolBar.add(sep);
		toolBar.add(bustext);
		toolBar.add(buscar);
		//Devolvemos la Barra de Herramientas.
		return toolBar;
	}
}