import javax.swing.ImageIcon;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JSeparator;
import java.net.URL;

public class BarraDeMenus
{

	//URL de los Iconos para tenerlos listos para empaquetado.
	URL url0 = this.getClass().getResource("images/New24.gif");
	URL url1 = this.getClass().getResource("images/Open24.gif");
	URL url2 = this.getClass().getResource("images/SaveAs24.gif");
	URL url3 = this.getClass().getResource("images/Exit24.gif");
	URL url4 = this.getClass().getResource("images/Help24.gif");
	URL url5 = this.getClass().getResource("images/Information24.gif");
	URL url6 = this.getClass().getResource("images/Preferences24.gif");
	URL url7 = this.getClass().getResource("images/Close24.gif");
	URL url8 = this.getClass().getResource("images/Cut24.gif");
	URL url9 = this.getClass().getResource("images/Copy24.gif");
	URL url10 = this.getClass().getResource("images/Paste24.gif");
	URL url11 = this.getClass().getResource("images/Find24.gif");
	URL url12 = this.getClass().getResource("images/NewC24.gif");
	URL url13 = this.getClass().getResource("images/NewJ24.gif");
	URL url14 = this.getClass().getResource("images/NewW24.gif");

	//Definicin de los Iconos anteriores como ImageIcon.
	ImageIcon im0 = new ImageIcon(url0);
	ImageIcon im1 = new ImageIcon(url1);
	ImageIcon im2 = new ImageIcon(url2);
	ImageIcon im3 = new ImageIcon(url3);
	ImageIcon im4 = new ImageIcon(url4);
	ImageIcon im5 = new ImageIcon(url5);
	ImageIcon im6 = new ImageIcon(url6);
	ImageIcon im7 = new ImageIcon(url7);
	ImageIcon im8 = new ImageIcon(url8);
	ImageIcon im9 = new ImageIcon(url9);
	ImageIcon im10 = new ImageIcon(url10);
	ImageIcon im11 = new ImageIcon(url11);
	ImageIcon im12 = new ImageIcon(url12);
	ImageIcon im13 = new ImageIcon(url13);
	ImageIcon im14 = new ImageIcon(url14);

	//Definicin de la Barra de Menu.
	JMenuBar barrademenus = new JMenuBar();

	//Menus de la Barra de Menus.
	JMenu archivo = new JMenu("Archivo");
	JMenu editar = new JMenu("Editar");
	JMenu prefs = new JMenu("Preferencias");
	JMenu proyectos = new JMenu("Proyectos");
	JMenu documentos = new JMenu("Documentos");
	JMenu ayuda = new JMenu("Ayuda");
	//Aqui pondremos los Elementos de Menus.

	//Menu Archivo  	
	JMenuItem nuevo = new JMenuItem("Nuevo", im0);
	JMenu njava = new JMenu("Nuevo...");
	JMenuItem arlsagpi = new JMenuItem("Archivo ADV", im14);
	JSeparator seplsagpi = new JSeparator();
	JMenuItem prlsagpi = new JMenuItem("Proyecto LSAGPI ADV");
	JMenuItem cuarlsagpi = new JMenuItem("Cuarto LSAGPI ADV");
	JSeparator sepnav = new JSeparator();
	JMenuItem navi = new JMenuItem("API LSAGPI");
	JSeparator sep1 = new JSeparator();
	JMenuItem abrir = new JMenuItem("Abrir", im1);
	JMenuItem cerrar = new JMenuItem("Cerrar", im7);
	JMenuItem closeall = new JMenuItem("Cerrar todo");
	JMenuItem guardar = new JMenuItem("Guardar Como...", im2);
	JSeparator sep2 = new JSeparator();
	JMenuItem imprimir = new JMenuItem("Imprimir");
	JSeparator sep32 = new JSeparator();
	JMenuItem salir = new JMenuItem("Salir", im3);

	//Menu Editar
	JMenuItem undo = new JMenuItem("Deshacer");
	JMenuItem redo = new JMenuItem("Rehacer");
	JSeparator sepdo = new JSeparator();
	JMenuItem copiar = new JMenuItem("Copiar", im9);
	JMenuItem cortar = new JMenuItem("Cortar", im8);
	JMenuItem pegar = new JMenuItem("Pegar", im10);
	JSeparator sep3 = new JSeparator();
	JMenuItem buscar = new JMenuItem("Buscar...", im11);
	JSeparator sep334 = new JSeparator();
	JMenuItem irlinea = new JMenuItem("Ir a Linea...");
	JMenuItem selectall = new JMenuItem("Seleccionar todo");
	JMenu sintaxis = new JMenu("Coloreado de Sintaxis");
	JMenuItem sinTexto = new JMenuItem("Texto Plano");
	JMenuItem sinLSAGPI = new JMenuItem("LSAGPI");
	//Menu Proyectos
	
	JMenuItem prpreview = new JMenuItem("Ejecutar");
	

	//Menu Preferencias 	
	JMenuItem preferencias = new JMenuItem("Preferencias...", im6);

	//Menu Acerca de...  	
	JMenuItem indice = new JMenuItem("Indice", im4);
	JMenuItem acerca = new JMenuItem("Acerca de...", im5);

	public JMenuBar getMenuBar()
	{
		//Dentro de la clase getMenuBar() aadiremos cada elemento a su menu correspondiente.
		//Menu Archivo		
		archivo.add(nuevo);
		archivo.add(njava);
		njava.add(arlsagpi);
		njava.add(seplsagpi);
		njava.add(prlsagpi);
		njava.add(cuarlsagpi);
		njava.add(sepnav);
		njava.add(navi);
		archivo.add(sep1);
		archivo.add(abrir);
		archivo.add(cerrar);
		archivo.add(closeall);
		archivo.add(guardar);
		archivo.add(sep32);
		archivo.add(salir);

		//Menu Editar
		editar.add(undo);
		editar.add(redo);
		editar.add(sepdo);
		editar.add(copiar);
		editar.add(cortar);
		editar.add(pegar);
		editar.add(sep3);
		editar.add(buscar);
		editar.add(sep334);
		editar.add(selectall);
		editar.add(irlinea);
		editar.add(sintaxis);
		sintaxis.add(sinTexto);
		sintaxis.add(sinLSAGPI);

		//Menu Proyectos
		
		proyectos.add(prpreview);
		

		//Menu Preferencias
		//prefs.add(preferencias);

		//Menu Ayuda
		ayuda.add(indice);
		ayuda.add(acerca);

		//Barra de Menus
		barrademenus.add(archivo);
		barrademenus.add(editar);
		barrademenus.add(proyectos);
		//barrademenus.add(prefs);
		barrademenus.add(documentos);//Documentos se rellenara dinmicamente por eso aqui solo esta su definicin.
		barrademenus.add(ayuda);

		//Devolvemos la Barra de Menus ya formada.
		return barrademenus;
	}

}