import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.UndoManager;
import java.util.Vector;

import com.Ostermiller.Syntax.*;

//Empezamos la Clase CreadorADV.
public class CreadorADV extends JFrame {
  
  //Iniciamos los Contadores para Pestaas y Documentos.	
  int i=0;
  int k=0;
  //Definimos una cadena de texto para cargar y guardar archivos.
  String ar;
  
  //Definimos un Array de Paneles de Texto dimensionado inicialmente a 20.
  JTextPane[] v=new JTextPane[20];
	Vector ruta_archivo = new Vector(20);
  //Definimos un panel donde agregar las Barras de Menus y de Herramientas.
  JPanel menustool=new JPanel();
  
  //Definimos las Barras de menus y de herramientas.
  BarraDeMenus barrademenus=new BarraDeMenus();
  BarraDeHerramientas barradeherramientas=new BarraDeHerramientas();
  
  //Definimos la clase auxiliar para el aspecto de la ventana, para darle un poco de vistosidad al editor.
  SeleccionLookAndFeel sellaf=new SeleccionLookAndFeel();
  
  //Definimos una Barra de Estado que cambiaremos segn el estado del programa.
  JLabel etiqueta=new JLabel("Documento Nuevo");
  JLabel lineas = new JLabel("Lneas 0, 0:0");
	JPanel barraestado = new JPanel();

  //Definimos un selector de archivos para cargar y guardar nuestros cdigos de forma comoda.	
  JFileChooser fc=new JFileChooser();
  
  //????
  ImageIcon icon = new ImageIcon("images/middle.gif");
  //Definimos un panel de Pestaas para hacer a nuestro editor Multidocumento.
  JTabbedPane tabbedPane = new JTabbedPane();
	
  //Definimos un JSplitPane para dividir el centro en un JTabbedPane y un JTextArea no editable para depuracin.
	JTextArea depurador = new JTextArea();
	JScrollPane depuscroll = new JScrollPane(depurador);
	JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT, tabbedPane, depuscroll);
	
  //Empezamos la clase principal CreadorADV.
  public CreadorADV() {

    //Seleccionamos un marco de borde para la ventana principal.
  	getContentPane().setLayout(new BorderLayout());  	

    //Implementamos el evento cerrar aplicacin.
	addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				System.exit(0);
				}});
	
	  //Definimos las acciones del Menu Archivo, Nuevo (C, Java, Api), Abrir, Cerrar, Cerrar Todos, Guardar y Salir. 
	  
	
	  //Nuevo ADV
		barrademenus.arlsagpi.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				//Llama al mtodo para crear nuevo panel de ADV.
				Component nuevo = makeTextLSAGPIPanel();
				tabbedPane.addTab("Nuevo ADV", icon, nuevo, "Nueva Aventura");//Aade el Panel  en una pestana nueva.
				tabbedPane.setSelectedIndex(i);//Selecciona la pestaa recien aadida.
				barrademenus.documentos.insert("Nuevo ADV", i);//Inserta la Pestaa en el Menu Documentos.
				final int a = i;
				//Iguala los indices del Menu Documentos y del Panel de Pestaas.
				barrademenus.documentos.getItem(i).addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent ej) { tabbedPane.setSelectedIndex(a); }
				});
				i++;//Inclementamos los valores de Documentos y Pestaas.
				k++;

			}
		});
		barrademenus.prlsagpi.addActionListener(new NuevoWebOS());//crear proyecto en directorio dado (en principioJOptionPane) y abrir archivos.
		barrademenus.cuarlsagpi.addActionListener(new NuevoArchivo());//Aadir escena a proyecto y actualizar archivos
		//Usaremos este Panel para navegar por el API de Java, es un navegador simple de paginas web.
       	barrademenus.navi.addActionListener(new ActionListener(){
    		public void actionPerformed(ActionEvent e){
				//Llama al mtodo para crear nuevo panel de Navegador API.
      			Component nuevo=makeNavigatorPanel();
				tabbedPane.addTab("API LAGPI", icon, nuevo, "Ayuda LSAGPI");//Aade el Panel  en una pestana nueva.
				tabbedPane.setSelectedIndex(i);//Selecciona la pestaa recien aadida.
				barrademenus.documentos.insert("API LSAGPI", i);//Inserta la Pestaa en el Menu Documentos.
 				final int a=i;
				//Iguala los indices del Menu Documentos y del Panel de Pestaas.
 				barrademenus.documentos.getItem(i).addActionListener(new ActionListener(){
 					public void actionPerformed(ActionEvent ej){tabbedPane.setSelectedIndex(a);}});
				i++;//Inclementamos los valores de Documentos y Pestaas.
 				k++;
       	 	
       	}});
    
	//Nuevo archivo en blanco llama a la clase NuevoArchivo().
  	barrademenus.nuevo.addActionListener(new NuevoArchivo());

	//Cerrar archivo llama a la clase CerrarArchivo().
  	barrademenus.cerrar.addActionListener(new CerrarArchivo());
	
    //Cerrar Todos. Elimina todas las Pestaas y vacia el Menu Documentos.
	barrademenus.closeall.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
			tabbedPane.removeAll();
			barrademenus.documentos.removeAll();
	}});

	//Abrir archivo llama a la clase AbrirArchivo().
  	barrademenus.abrir.addActionListener(new AbrirArchivo());

	//Guardar archivo llama a la clase GuardarArchivo().
  	barrademenus.guardar.addActionListener(new GuardarArchivo());
    	//barrademenus.imprimir.addActionListener(new ImprimirTexto());
   
   	//Salir, sale del Programa llamando a la clase SalirPrograma.
	barrademenus.salir.addActionListener(new SalirPrograma());

	//Definimos las acciones del Menu Editar, Cortar, Copiar, Pegar, Buscar y Seleccionar Todo.
	barrademenus.undo.setEnabled(false);
	barrademenus.redo.setEnabled(false);
	barrademenus.undo.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			try
			{
				int gh = tabbedPane.getSelectedIndex(); //Seleccionamos el panel de Texto correspondiente.
				//v[gh].getUndoManager().undo(); 
			}
			catch (CannotRedoException cre)
			{
				cre.printStackTrace();
			}
			updateButtons();
		}
	});

	barrademenus.redo.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			try
			{
				int gh = tabbedPane.getSelectedIndex(); //Seleccionamos el panel de Texto correspondiente.
				//v[gh].getUndoManager().redo(); 
			}
			catch (CannotRedoException cre)
			{
				cre.printStackTrace();
			}
			updateButtons();
		}
	});

	barrademenus.cortar.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			int gh = tabbedPane.getSelectedIndex(); //Seleccionamos el panel de Texto correspondiente.
			v[gh].cut();//Cortamos.
		}
	});
	barrademenus.copiar.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			int gh = tabbedPane.getSelectedIndex();//Seleccionamos el panel de Texto correspondiente.
			v[gh].copy();//Copiamos.
		}
	});
	barrademenus.pegar.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			int gh = tabbedPane.getSelectedIndex();//Seleccionamos el panel de Texto correspondiente.
			v[gh].paste();//Pegamos.
		}
	});
	barrademenus.buscar.addActionListener(new BusCadena()); //Llama a la clase BusCadena().
	barrademenus.irlinea.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			int gh = tabbedPane.getSelectedIndex(); //Seleccionamos el panel de Texto correspondiente.
			String seleccion = JOptionPane.showInputDialog(
   CreadorADV.this, "Introduce el nmero de lnea", JOptionPane.QUESTION_MESSAGE);
			v[gh].setCaretPosition(1);
			while (Integer.parseInt(seleccion) != UTextComponent.getLineAtCaret(v[gh]))
			{ v[gh].setCaretPosition(v[gh].getCaretPosition() + 1); }
			
		}
	});
	barrademenus.selectall.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			int gh = tabbedPane.getSelectedIndex(); //Seleccionamos el panel de Texto correspondiente.
			v[gh].selectAll();//Seleccionamos todo.
		}
	});

	//Coloreado de Sintaxis para LSAGPI, por implementar.
	  barrademenus.sinTexto.addActionListener(new Sintaxis(HighlightedDocument.PLAIN_STYLE));
	  barrademenus.sinLSAGPI.addActionListener(new Sintaxis(HighlightedDocument.LSAGPI_STYLE));
	  
	//Definimos las acciones del Menu Preferencias.
	//Ventana de Preferencias, llama la clase Prefs().
	barrademenus.preferencias.addActionListener(new Prefs());

	//Definimos las acciones del Menu Ayuda, Indice y Acerca de.
    //Indice de la Ayuda. Llama a la clase Index();
	barrademenus.indice.addActionListener(new Index());  
	//Ventana Acerca de, llama la clase Acerca().
	barrademenus.acerca.addActionListener(new Acerca());

	//Definimos las acciones del Menu Proyectos, no implementado.
	/*
	barrademenus.nproyecto.addActionListener(new Action1());
	barrademenus.addproyecto.addActionListener(new Action2());
barrademenus.prpreview.addActionListener(new Action3());
barrademenus.prcomp.addActionListener(new Action4());
barrademenus.prjar.addActionListener(new Action5());
	*/
	
	
    //Definimos las acciones de la Barra de Herramientas que son comunes a las de la barra de Menus.
	barradeherramientas.nue.addActionListener(new NuevoArchivo()); 
	barradeherramientas.ab.addActionListener(new AbrirArchivo());
	barradeherramientas.save.addActionListener(new GuardarArchivo());
	barradeherramientas.close.addActionListener(new CerrarArchivo());
	barradeherramientas.exit.addActionListener(new SalirPrograma());
    barradeherramientas.buscar.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			int gh = tabbedPane.getSelectedIndex(); //Seleccionamos el panel de Texto correspondiente.
			BuscarCadena.find(v[gh], barradeherramientas.bustext.getText(), false, false);//Seleccionamos todo.
		}
	});
    
    //Colocamos las Barras de menus y de herramientas en el Panel de menus.	
 	menustool.setLayout(new BorderLayout());
 	menustool.add("North",barrademenus.getMenuBar());
 	menustool.add("South",barradeherramientas.getToolBar());

    //Seleccionamos el aspecto del SplitPane.
	split.setOneTouchExpandable(true);
	depuscroll.setVisible(false);

	 
	  //Ponemos un nuevo panel de Texto en blanco.
	Component nuevo = makeTextPanel();
	//UndoManager undoManager = new UndoManager();

	tabbedPane.addTab("Nuevo", icon, nuevo, "Nuevo archivo");
	tabbedPane.setSelectedIndex(i);
	barrademenus.documentos.insert("Nuevo", i);
	final int a = i;
	barrademenus.documentos.getItem(i).addActionListener(new ActionListener() { public void actionPerformed(ActionEvent ej) { tabbedPane.setSelectedIndex(a); } });
	i++;
	k++;

	  //Definimos la Barra de Estado.
	barraestado.setLayout(new BorderLayout());
	barraestado.add("West", etiqueta);
	barraestado.add("East", lineas);
	  //Definimos la Ventana Principal arriba el panel de menus, en el centro el panel de 
	    //Pestaas y abajo la barra de estado.
	
	
        getContentPane().add("North",menustool);
        getContentPane().add("Center",split);
       	getContentPane().add("South",barraestado);
		
    }
	//Mtodo para crear un panel de Texto Simple.
	public void updateButtons()
	{
		int gh = tabbedPane.getSelectedIndex(); //Seleccionamos el panel de Texto correspondiente.
		//barrademenus.undo.setEnabled(v[gh].getUndoManager().canUndo());
		//barrademenus.redo.setEnabled(v[gh].getUndoManager().canUndo());
	}

    public Component makeTextPanel() {
        final JTextPane filler = new JTextPane();
		final UndoManager undoManager = new UndoManager();
		filler.getDocument().addUndoableEditListener(
		new UndoableEditListener()
		{
			public void undoableEditHappened(UndoableEditEvent e)
			{
				undoManager.addEdit(e.getEdit());
				updateButtons();
			}
		});

		filler.addCaretListener(new CaretListener()
		{
			public void caretUpdate(CaretEvent e)
			{
				lineas.setText("Lneas " + UTextComponent.getLines(filler) + ", " + UTextComponent.getLineAtCaret(filler) + ":" + UTextComponent.getColumnAtCaret(filler));
			}
		});
        JScrollPane panel = new JScrollPane(filler);
         
       v[i]=filler;
     
          return panel;
    }

	//Mtodo para crear un panel de Navegacin del API Java.
 public Component makeNavigatorPanel(){
 	Navegador navi=new Navegador();
	navi.iraPagina("http://cusl5-lsagpim.forja.rediris.es/manual.html");
 	v[i]=navi.getTextPane();
 	return navi;
 }
 //Mtodo para crear un panel con Nuevo archivo ADV con resalte de Sintaxis.
 	
	public Component makeTextLSAGPIPanel()
	{
		HighlightedDocument document = new HighlightedDocument();
		document.setHighlightStyle(HighlightedDocument.LSAGPI_STYLE);
		final JTextPane filler = new JTextPane(document);
		final UndoManager undoManager = new UndoManager();
		filler.getDocument().addUndoableEditListener(
		   new UndoableEditListener()
		{
			public void undoableEditHappened(UndoableEditEvent e)
			{
				undoManager.addEdit(e.getEdit());
				updateButtons();
			}
		});
		JScrollPane panel = new JScrollPane(filler);
		filler.setText("SISTEMA\n{\n    ANDAR\n    {\n        ETIQUETA { \"Andar a\" }\n	  IMAGEN { \"gr/btn_andara.jpg\" }\n        TINTA { 0 255 255 }\n	PAPEL { 0 0 0 }\n        TECLA { \"w\" }\n    }\n    VERBO Dar\n    {\n        ETIQUETA { \"Dar\" }\n	  IMAGEN { \"gr/btn_dar.jpg\" }\n        SENTENCIA { 2 \"a\" }\n        TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n        TECLA { \"g\" }\n    }\n    VERBO Coger\n    {\n        ETIQUETA { \"Coger\" }\n	  IMAGEN { \"gr/btn_coger.jpg\" }\n        TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n	TECLA { \"p\" }\n    }\n    VERBO Usar\n    {\n        ETIQUETA { \"Usar\" }\n	  IMAGEN { \"gr/btn_usar.jpg\" }\n        SENTENCIA { * \"con\" }\n        TINTA { 165 156 132 }\n        PAPEL { 80 68 48 }\n        TECLA { \"u\" }\n        CONMUTATIVO { 1 }\n    }\n    VERBO Abrir\n    {\n        ETIQUETA { \"Abrir\" }\n	IMAGEN { \"gr/btn_abrir.jpg\" }\n        TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n	TECLA { \"o\" }\n    }\n    VERBO Hablar\n    {\n      ETIQUETA { \"Hablar a\" }\n	IMAGEN { \"gr/btn_hablara.jpg\" }\n      TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n      TECLA { \"t\" }\n    }\n    VERBO Push\n    {\n      ETIQUETA { \"Empujar\" }\n	IMAGEN { \"gr/btn_empujar.jpg\" }\n      TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n    }\n    VERBO Cerrar\n    {\n      ETIQUETA { \"Cerrar\" }\n	IMAGEN { \"gr/btn_cerrar.jpg\" }\n     TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n	TECLA { \"c\" }\n    }\n    VERBO Mirar\n    {\n        ETIQUETA { \"Mirar\" }\n	  IMAGEN { \"gr/btn_mirar.jpg\" }\n	  TINTA { 165 156 132 }\n	  PAPEL { 80 68 48 }\n        TECLA { \"l\" }\n    }\n    VERBO Pull\n    {\n      ETIQUETA { \"Tirar\" }\n	IMAGEN { \"gr/btn_tirar.jpg\" }\n      TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n    }\n    VERBODEFECTO { Mirar }\n    FPS { 20 }\n    ANGULOS { 4 }\n    PANTALLA { 640 480 }\n   JUGADOR { chaval }\n    INVENTARIO\n    {\n        TAMAO { 10 }\n        TINTA { 116 100 68 }\n        PAPEL { 80 68 48 }\n        IMAGEN\n        {\n        	\"gr/inv_arriba.jpg\"    \"gr/inv_arriba_c.jpg\"\n        	\"gr/inv_abajo.jpg\"    \"gr/inv_abajo_c.jpg\"\n        }\n    }\n   TITULO { \"Aventura sin Titulo\" }\n   CURSOR { \"gr/m_cross.gif\" 15 15 }\n   HABLAR\n    {\n      TAMAO { 4 }\n      TINTA { 165 156 132 }\n      PAPEL { 80 68 48 }\n      FUENTE { \"SansSerif\" 11 }\n    }\nFUENTE { \"SansSerif\" 20 }\nINICIO { \"principal\" }\n}");
		filler.addCaretListener(new CaretListener()
		{
			public void caretUpdate(CaretEvent e)
			{
				lineas.setText("Lneas " + UTextComponent.getLines(filler) + ", " + UTextComponent.getLineAtCaret(filler) + ":" + UTextComponent.getColumnAtCaret(filler));
			}
		});
		v[i] = filler;
		return panel;

	}
	//Mtodo para abrir un archivo.
    public Component makeabrirPanel() {
        
					fc.addChoosableFileFilter(new javax.swing.filechooser.FileFilter()
					{
						public boolean accept(File f)
						{
							return f.isDirectory() || f.getName().toLowerCase().endsWith(".adv");
						}
						public String getDescription()
						{
							return "Archivos .adv";
						}

					});
					
					
		HighlightedDocument document = new HighlightedDocument();
		final JTextPane filler = new JTextPane(document);
		final UndoManager undoManager = new UndoManager();
		filler.getDocument().addUndoableEditListener(
		   new UndoableEditListener()
		{
			public void undoableEditHappened(UndoableEditEvent e)
			{
				undoManager.addEdit(e.getEdit());
				updateButtons();
			}
		});
		
		JScrollPane panel = new JScrollPane(filler);
     	 
         try{
               FileReader in=null;
                int returnVal = fc.showOpenDialog(CreadorADV.this);
               
               File file;
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    
                    file = fc.getSelectedFile();
					ar=file.getName();
					if (file.getName().toLowerCase().endsWith(".adv"))
					{
						document.setHighlightStyle(HighlightedDocument.LSAGPI_STYLE);
					}
					else { document.setHighlightStyle(HighlightedDocument.PLAIN_STYLE); }
					etiqueta.setText("Documento abierto: " + file.getName() );
                    in=new FileReader(file);
                    filler.getEditorKit().read(in,filler.getDocument(),0);
                    filler.setCaretPosition(0);
					filler.addCaretListener(new CaretListener()
					{
						public void caretUpdate(CaretEvent e)
						{
							lineas.setText("Lneas " + UTextComponent.getLines(filler) + ", " + UTextComponent.getLineAtCaret(filler) + ":" + UTextComponent.getColumnAtCaret(filler));
						}
					});
					v[i]=filler;
                   
       		 return panel;
}
    }catch(IOException r){etiqueta.setText("No se pudo barrademenus.abrir el archivo"); 
    }catch(BadLocationException s){etiqueta.setText("No se pudo barrademenus.abrir el archivo");}
     return null;
    }


    //Funcion principal 
    public static void main (String[] args){
    //Creamos una Pantalla de Presentacin.
	SplashScreen v=new SplashScreen();
		v.makeASplash();//Hacemos Pantalla de Presentacin.
		v.setVisible(true);//La volvemos visible.
		v.dispose();//La cerramos.
    CreadorADV e = new CreadorADV();//Cargamos el Editor.
    e.setTitle("Creador ADV v. 0.1");//Ponemos ttulo a la Ventana.
    e.setSize(800,600);//Elegimos el Tamao inicial.
	e.setVisible(true);//La volvemos visible.
  }

  //Clase para salir del programa.
  class SalirPrograma implements ActionListener{
  	 public void actionPerformed(ActionEvent e){System.exit(0);}
  	 }
  //Clase para crear un nuevo archivo.
  class NuevoArchivo implements ActionListener{
  public void actionPerformed(ActionEvent e){
    		    Component nuevo=makeTextPanel();
 				tabbedPane.addTab("Texto Plano",icon,nuevo,"Archivo de texto plano");
 				tabbedPane.setSelectedIndex(i);
 				barrademenus.documentos.insert("Texto Plano", i);
 				final int a=i;
 				 barrademenus.documentos.getItem(i).addActionListener(new ActionListener(){public void actionPerformed(ActionEvent ej){tabbedPane.setSelectedIndex(a);}});
 				i++;
 				k++;
       			     	}
       	}
	//Clase para Guardar un archivo.
	class GuardarArchivo implements ActionListener{
	public void actionPerformed(ActionEvent e){
  	  		int j=tabbedPane.getSelectedIndex();
  	  		 try{
               FileWriter out=null;
                int returnVal = fc.showSaveDialog(CreadorADV.this);
                
                File file;
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    file = fc.getSelectedFile();
                    tabbedPane.setTitleAt(j,file.getName());
                    out=new FileWriter(file);
                    BufferedWriter bw=new BufferedWriter(out);
                    PrintWriter salida=new PrintWriter(bw);
                    JTextPane p=new JTextPane();
                    p=v[(j)];
                     String w=new String(p.getText());
                   try{
                    p.getEditorKit().write(salida,p.getDocument(),0,w.length());
                    }catch(BadLocationException bed){}
                    //ek.write(salida,p.getDocument(),0,w.length());
                  
                   barrademenus.documentos.insert(file.getName(),j);
                     final int a=j;
                     barrademenus.documentos.remove(a);
                     barrademenus.documentos.getItem(i).addActionListener(new ActionListener(){
                     		public void actionPerformed(ActionEvent ej){tabbedPane.setSelectedIndex(a);}});
                     //salida.print(""+w);
                    salida.close();
                     etiqueta.setText("Documento almacenado como: " + file.getName() ); 
                      	} }catch(IOException r){etiqueta.setText("No se pudo abrir el archivo");}
  	  	 catch(NullPointerException f){}
  	  }}
	//Clase para Abrir un Archivo.
	class AbrirArchivo implements ActionListener{
	public void actionPerformed(ActionEvent e){
  			Component nuevo=makeabrirPanel();
 			if(nuevo!=null){
 				tabbedPane.addTab(ar,icon,nuevo,"Lo que hace");
 				 tabbedPane.setSelectedIndex(i);
 				 barrademenus.documentos.insert(ar,i);
 				 final int a=i;
 				 barrademenus.documentos.getItem(i).addActionListener(new ActionListener(){public void actionPerformed(ActionEvent ej){tabbedPane.setSelectedIndex(a);}});
 				 i++;
 				 k++;
 				}}}
	//Clase para cerrar un Archivo.
	class CerrarArchivo implements ActionListener{
	public void actionPerformed(ActionEvent e){
    		    Object[] options = {"Aceptar", "Cancelar"};
    			int n = JOptionPane.showOptionDialog(null,
        		"Desea cerrar sin grabar los cambios? " ,
        		"Nuevo Fichero Java",
        		JOptionPane.YES_NO_OPTION,
        		JOptionPane.QUESTION_MESSAGE,
       			 null,	options, options[1]);
       			if(n==JOptionPane.YES_OPTION){
       				 int j=tabbedPane.getSelectedIndex();
 	 		tabbedPane.removeTabAt(j);
 	 		barrademenus.documentos.remove(j);
 	 		i--;
 	 		k--;
       					}
       			     		
       			     	}
       	}

       /*	class ImprimirTexto implements ActionListener{
       		public void actionPerformed(ActionEvent e){
       		 // Get a PrinterJob
    		PrinterJob job = PrinterJob.getPrinterJob();
    		// Create a landscape page format
   		 PageFormat landscape = job.defaultPage();
    		landscape.setOrientation(PageFormat.LANDSCAPE);
    		// Set up a book
    		Book bk = new Book();
   		bk.append(new PaintCover(), job.defaultPage());
    		bk.append(new PaintContent(), landscape);
    		// Pass the book to the PrinterJob
    		job.setPageable(bk);
    		// Put up the dialog box
    		if (job.printDialog()) {
        	// Print the job if the user didn't cancel printing
        	try { job.print(); }
         	   catch (Exception exc) { Handle Exception  }
 		  }
	}}
 
 */
 //Clase para buscar una cadena en un panel de texto.
 class BusCadena implements ActionListener{
       		
       		public void actionPerformed(ActionEvent e){
       			BuscarCadena a=new BuscarCadena(CreadorADV.this,v,tabbedPane);
       			a.setSize(294,87);
				a.setVisible(true); 
 		  }
	}
//Clase para mostrar el cuadro Preferencias.
	class Sintaxis implements ActionListener
	{
		Object tipo;
		public Sintaxis(Object estilo) {
			tipo = estilo;
		}
		public void actionPerformed(ActionEvent e)
		{
			int ik = tabbedPane.getSelectedIndex();
			HighlightedDocument document = new HighlightedDocument();
			document.setHighlightStyle(tipo);
			String documento = v[ik].getText();
			v[ik].setDocument(document);
			v[ik].setText(documento);
		}
	}
	
class Prefs implements ActionListener{
		
		public void actionPerformed(ActionEvent e){
       			Preferencias a=new Preferencias(CreadorADV.this);
       			a.setSize(411,467);
				a.setVisible(true); 
 		  }
	}
//Clase para mostrar el Indice de la Ayuda.
class Index implements ActionListener
	{

		public void actionPerformed(ActionEvent e)
		{
			Indice a = new Indice(CreadorADV.this);
			a.setSize(411, 467);
			a.setVisible(true);
		}
	}
//Clase para mostrar el cuadro Acerca de.
class Acerca implements ActionListener
	{

		public void actionPerformed(ActionEvent e)
		{
			AboutBox a = new AboutBox(CreadorADV.this);
			a.setSize(500, 400);
			a.setVisible(true);
		}
	}

//Clase para el Creador de Menus.
class Creador implements ActionListener{
		
		public void actionPerformed(ActionEvent e){
       			CreadordeMenus a=new CreadordeMenus(CreadorADV.this);
       			a.setSize(640,480);
				a.setVisible(true); 
 		  }
	}
class NuevoWebOS extends Thread implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{ this.start(); }
		public void run()
		{
			String titulo=null;
			String clase;
			String version;
			String nombre=null;
			Process ls_proc;
			String ruta = new String("C:\\Documents and Settings\\Miguel Angel\\PalmDev\\");
			if (ruta.equals(null))
			{
				System.out.println("");
			}
			else
			{
				try
				{
					String contenido = new String("");
					String ls_str;
					titulo = JOptionPane.showInputDialog("Introduzca el Nombre del Programa:");
					clase = JOptionPane.showInputDialog("Introduzca la clase de referencia:\n (Ej: com.micompaia.miprograma)");
					version = JOptionPane.showInputDialog("Introduzca la Versin del programa:\n (Ej: 1.0.0)");
					nombre = JOptionPane.showInputDialog("Introduzca el nombre MS-DOS del programa:\n(8 caracteres sin espacios)"); 
					try
						{
							Thread.sleep(100);
						}
						catch (InterruptedException e)
						{
							System.out.println("Pausa");
						}

						etiqueta.setText("Creando proyecto WebOs.");
						String cmd[] ={"C:\\Archivos de programa\\Palm\\SDK\\bin\\palm-generate.bat", "-p", "{title:'"+titulo+"', id:"+clase+", version:'"+version+"'}", ruta + nombre };
						ls_proc = Runtime.getRuntime().exec(cmd);
						BufferedReader ls_in = new BufferedReader(new InputStreamReader(ls_proc.getErrorStream()));
						while ((ls_str = ls_in.readLine()) != null)
						{
							if (ls_str != null)
								contenido += ls_str + "\n";
						}
					depuscroll.setVisible(true);
					depurador.setText(contenido);

				
			}catch (IOException e65) { System.err.println(e65); }
		//////////////////////////////////////////////////////////////////////
			Component nuevo_uno = makeWebOsPanel(ruta + nombre + "\\index.html");
 				if(nuevo_uno!=null){
 				tabbedPane.addTab(ar,icon,nuevo_uno,"Lo que hace");
 				 tabbedPane.setSelectedIndex(i);
 				 barrademenus.documentos.insert(ar,i);
 				 final int a=i;
 				 barrademenus.documentos.getItem(i).addActionListener(new ActionListener(){public void actionPerformed(ActionEvent ej){tabbedPane.setSelectedIndex(a);}});
 				 i++;
				 k++;
			 }
        ///////////////////////////////////////////////////////////////////////
			 Component nuevo_dos = makeWebOsPanel(ruta + nombre + "\\appinfo.json");
			 if (nuevo_dos != null)
			 {
				 tabbedPane.addTab(ar, icon, nuevo_dos, "Lo que hace");
				 tabbedPane.setSelectedIndex(i);
				 barrademenus.documentos.insert(ar, i);
				 final int a = i;
				 barrademenus.documentos.getItem(i).addActionListener(new ActionListener() { public void actionPerformed(ActionEvent ej) { tabbedPane.setSelectedIndex(a); } });
				 i++;
				 k++;
			 }
			 ///////////////////////////////////////////////////////////////////////
			 Component nuevo_tres = makeWebOsPanel(ruta + nombre + "\\sources.json");
			 if (nuevo_tres != null)
			 {
				 tabbedPane.addTab(ar, icon, nuevo_tres, "Lo que hace");
				 tabbedPane.setSelectedIndex(i);
				 barrademenus.documentos.insert(ar, i);
				 final int a = i;
				 barrademenus.documentos.getItem(i).addActionListener(new ActionListener() { public void actionPerformed(ActionEvent ej) { tabbedPane.setSelectedIndex(a); } });
				 i++;
				 k++;
			 }
			 ///////////////////////////////////////////////////////////////////////
			 Component nuevo_cuatro = makeWebOsPanel(ruta + nombre + "\\stylesheets\\"+titulo.toLowerCase().replaceAll(" ", "")+".css");
			 if (nuevo_cuatro != null)
			 {
				 tabbedPane.addTab(ar, icon, nuevo_cuatro, "Lo que hace");
				 tabbedPane.setSelectedIndex(i);
				 barrademenus.documentos.insert(ar, i);
				 final int a = i;
				 barrademenus.documentos.getItem(i).addActionListener(new ActionListener() { public void actionPerformed(ActionEvent ej) { tabbedPane.setSelectedIndex(a); } });
				 i++;
				 k++;
			 }
			 ///////////////////////////////////////////////////////////////////////
			 Component nuevo_cinco = makeWebOsPanel(ruta + nombre + "\\app\\assistants\\stage-assistant.js");
			 if (nuevo_cinco != null)
			 {
				 tabbedPane.addTab(ar, icon, nuevo_cinco, "Lo que hace");
				 tabbedPane.setSelectedIndex(i);
				 barrademenus.documentos.insert(ar, i);
				 final int a = i;
				 barrademenus.documentos.getItem(i).addActionListener(new ActionListener() { public void actionPerformed(ActionEvent ej) { tabbedPane.setSelectedIndex(a); } });
				 i++;
				 k++;
			 }
			 
			}
		}
	public Component makeWebOsPanel(String archivo)
	{

		HighlightedDocument document = new HighlightedDocument();
		final JTextPane filler = new JTextPane(document);
		final UndoManager undoManager = new UndoManager();
		filler.getDocument().addUndoableEditListener(
		   new UndoableEditListener()
		{
			public void undoableEditHappened(UndoableEditEvent e)
			{
				undoManager.addEdit(e.getEdit());
				updateButtons();
			}
		});

		JScrollPane panel = new JScrollPane(filler);

		try
		{
			FileReader in = null;
			File file=new File(archivo);
			ar = file.getName();
			if (file.getName().toLowerCase().endsWith(".adv"))
				{
					document.setHighlightStyle(HighlightedDocument.LSAGPI_STYLE);
			}
			else{document.setHighlightStyle(HighlightedDocument.PLAIN_STYLE);}
			try
			{
				in = new FileReader(file);
				filler.getEditorKit().read(in, filler.getDocument(), 0);
			}
			catch (IOException iexc) { }
				filler.setCaretPosition(0);
				filler.addCaretListener(new CaretListener()
				{
					public void caretUpdate(CaretEvent e)
					{
						lineas.setText("Lneas " + UTextComponent.getLines(filler) + ", " + UTextComponent.getLineAtCaret(filler) + ":" + UTextComponent.getColumnAtCaret(filler));
					}
				});
				v[i] = filler;

				return panel;
			}		
		catch (BadLocationException s) { etiqueta.setText("No se pudo abrir el archivo"); }
		return null;
	}
	}
class Compilar extends Thread implements ActionListener 
	{
	public void actionPerformed(ActionEvent e)
	{ this.start(); }
		public void run()
		{
			Process ls_proc;
			String ruta = new String("C:\\Documents and Settings\\Miguel Angel\\Escritorio\\Sourceforge\\JEditor3");
			if (ruta.equals(null))
			{
				System.out.println("El archivo no esta guardado");
			}
			else
			{
				try
				{
					String contenido=new String("");
					String ls_str;
					int size=0;
					int i=0;
					File[] archivos = (new File(ruta+"\\srcestables")).listFiles(new java.io.FileFilter()
					{
						public boolean accept(File f)
						{
							return f.getName().toLowerCase().endsWith(".java");
						}
					}
					);
					try
					{
						for (int j = 0; (archivos[j].getPath()) != null; j++){
							size = j;
						}
					}
					catch (ArrayIndexOutOfBoundsException aioobe) { }
					while (i<size){
						try{
						Thread.sleep(100);
					}
					catch (InterruptedException e)
					{
						System.out.println("Pausa");
					}

						etiqueta.setText("Compilando "+archivos[i].getPath());
					String cmd[] ={ "javac", "-Xlint:deprecation", "-d", ruta + "\\pruebas", archivos[i].getPath() };
					ls_proc = Runtime.getRuntime().exec(cmd);
					BufferedReader ls_in = new BufferedReader(new InputStreamReader(ls_proc.getErrorStream()));
					while ((ls_str = ls_in.readLine()) != null)
					{
						if (ls_str != null)
							contenido += ls_str + "\n";
					}
					i++;
				}
					depuscroll.setVisible(true);
					depurador.setText(contenido);

				}
				catch (IOException e65) { System.err.println(e65); }
			}
		}
	}
//Otras Clases por Implementar.
/*
class Action1 extends JDialog implements ActionListener{
//Nombre proyecto->abrir nuevo CreadorADV->crear directorio->crear archivo de proyecto(*.JEP) con indice de ficheros
}
class Action2 extends JDialog implements ActionListener{
//Abrir fichero proyecto y aadir nombres de ficheros del proyecto(*.JEP)
}
class Action3 extends JDialog implements ActionListener{
//Generar una ventana con un GUI que represente el programa basandose en los ficheros realizados y exiguiendo la ventana y la distribucin del espacio(Layout).
}
class Action4 extends JDialog implements ActionListener{
//Llamar a javac para compilar los ficheros del proyecto basandose en la informacin del fichero de proyecto (*.JEP)
}
class Action5 extends JDialog implements ActionListener{
//Crear fichero jar con nombre del proyecto y con todos los archivos que contiene-> Opcionalmente crear autoinstalables
}
*/
/*class Action6 extends JDialog implements ActionListener{
//Lista y cuadros de texto que pidan los datos de los menus estilo VisualBasic->Escribir con ellos el archivo BarraDeMenus.java
JLabel nmenu=new JLabel("Nombre del Menu",SwingConstants.RIGHT);
JLabel ntexto=new JLabel("Texto del Menu",SwingConstants.RIGHT);
JLabel nicono=new JLabel("Icono del Menu",SwingConstants.RIGHT);

//JLabel =new JLabel();
JTextField tmenu=new JTextField(20);
JTextField ttexto=new JTextField(20);
JTextField ticono=new JTextField(20);
//JTextField =new JTextField();
JButton farriba=new JButton();//llevan Iconos
JButton fabajo=new JButton();
JButton sep=new JButton();
JButton fsubmenu=new JButton();
JButton eliminar=new JButton("Eliminar Menu");
JButton addmenu=new JButton("Aadir Menu");
JButton fmenu=new JButton();
DefaultListModel listModel;
JList lista;
//Botones tpicos
JButton aceptar=new JButton("Aceptar");
JButton cancelar=new JButton("Cancelar");
JButton ayuda=new JButton("Ayuda");
//Paneles para situar los elementos
JPanel arriba=new JPanel();
JPanel centro=new JPanel();
JPanel abajo=new JPanel();
JPanel flechas=new JPanel();
String[][] menus;
int i=0;
JScrollPane scrollPane;
 
public Action6(){
	
	super(CreadorADV.this,"Creador de menus",true);
	listModel = new DefaultListModel();
	listModel.addElement("  ");
	lista = new JList(listModel);
        lista.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	lista.setSelectedIndex(0);
        //list.addListSelectionListener(this);
	scrollPane = new JScrollPane(lista);
	getContentPane().setLayout(new BorderLayout());
	arriba.setLayout(new GridLayout(4,2));
	arriba.add(nmenu);
	arriba.add(tmenu);
	arriba.add(ntexto);
	arriba.add(ttexto);
	arriba.add(nicono);
	arriba.add(ticono);
	arriba.add(eliminar);
	arriba.add(addmenu);
	centro.setLayout(new BorderLayout());
	centro.add("Center",lista);
		flechas.setLayout(new BorderLayout());
		flechas.add("North",farriba);
		flechas.add("East",fsubmenu);
		flechas.add("Center",sep);
		flechas.add("West",fmenu);
		flechas.add("South",fabajo);
	centro.add("West",flechas);
	centro.add("Center",scrollPane);
	abajo.setLayout(new GridLayout(1,3));
	abajo.add(aceptar);
	abajo.add(cancelar);
	abajo.add(ayuda);
	getContentPane().add("North",arriba);
	getContentPane().add("Center",centro);
	getContentPane().add("South",abajo);
	cancelar.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){dispose();}});
	addmenu.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){
		menus[i][0]=ttexto.getText();
		menus[i][1]=tmenu.getText();
		menus[i][2]=ticono.getText();
		i++;
		listModel.addElement(ttexto.getText());
		lista.setSelectedIndex(i);
        
	}});
	}
	public void actionPerformed(ActionEvent e){
       			Action6 a=new Action6();
       			a.setSize(480,480);
       			a.show();
	}

}	*/
 
}